Ruby: pm_array_node Struct Reference

Ruby 4.0.5p0 (2026-05-20 revision 64336ffd0ee9e1f4c05891695a3d7b49cb709721)

Data Fields
pm_array_node Struct Reference

ArrayNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
struct pm_node_list | elements
| ArrayNode#elements.
pm_location_t | opening_loc
| ArrayNode#opening_loc.
pm_location_t | closing_loc
| ArrayNode#closing_loc.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

ArrayNode.

Represents an array literal. This can be a regular array using brackets or a special array using % like w or i.

    [1, 2, 3]
    ^^^^^^^^^

Type: ::PM_ARRAY_NODE

Flags (#pm_array_node_flags):

- ::PM_ARRAY_NODE_FLAGS_CONTAINS_SPLAT

Definition at line 1364 of file ast.h.

## Field Documentation

## ◆ base

pm_node_t pm_array_node::base

The embedded base node.

Definition at line 1366 of file ast.h.

Referenced by pm_dump_json().

## ◆ closing_loc

pm_location_t pm_array_node::closing_loc

ArrayNode#closing_loc.

Represents the optional source location for the closing token.

    [1,2,3]                 # "]"
    %w[foo bar baz]         # "]"
    %I(apple orange banana) # ")"
    foo = 1, 2, 3           # nil

Definition at line 1398 of file ast.h.

Referenced by pm_dump_json().

## ◆ elements

struct pm_node_list pm_array_node::elements

ArrayNode#elements.

Represent the list of zero or more non-void expressions within the array.

Definition at line 1374 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ opening_loc

pm_location_t pm_array_node::opening_loc

ArrayNode#opening_loc.

Represents the optional source location for the opening token.

    [1,2,3]                 # "["
    %w[foo bar baz]         # "%w["
    %I(apple orange banana) # "%I("
    foo = 1, 2, 3           # nil

Definition at line 1386 of file ast.h.

Referenced by pm_dump_json().

The documentation for this struct was generated from the following file:

- prism/ast.h